CON                          
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

OBJ

pst : "Parallax Serial Terminal"
XB  : "Xbee_Object V2.0"
str : "STRINGS2"
nums : "Simple_Numbers"
str2 : "ASCII0_STREngine_1"
VAR
byte  databuffer[100]
PUB Main      | ptr, lsb, msb, og, length, index, index2, output[5], offset, lsb2
pst.start(9600)
og := string("123,4114,2,551,23,")
length := strsize(og)
pst.Str(String("Packet received = "))
pst.Str(og)
pst.newline
pst.Str(String("Packet length = "))
pst.dec(length)
pst.newline
pst.Str(String("Initial offset = "))
pst.dec(offset)
pst.newline
pst.newline
pst.newline

'' Creating loops to manage any string packet size

repeat index from length to 0
   databuffer[index - 1] := get_char(og, index - 1)


repeat 5                    '' I should know in advance how many variables
                            '' to receive, in this case it is 5

    offset := str.charpos(og, ",", offset, length) 
    pst.Str(String("Comma location = "))
    pst.dec(offset)
    pst.newline
    lsb := offset - 1
    repeat index2 from msb to lsb
      output[ptr] := str2.buildstring(databuffer[index2])
      output[ptr] := str2.builtstring(output[ptr])
    msb :=  offset + 1
    
    pst.str(output[ptr])    '' This should print each reading in its variable'                   
    ptr++                   '' output[0]=123, output[1]=4114, and so on, but it does not
    pst.newline
    pst.str(og)             '' Printing packet again just to check if it did
    pst.newline             '' not change
    pst.newline
    waitcnt(clkfreq + cnt)
''''''''''''''''            '' Printing again to double check! 
pst.newline
pst.str(output[0])                    
pst.newline
pst.str(output[1])                    
pst.newline
pst.str(output[2])                    
pst.newline
pst.str(output[3])                    
pst.newline
pst.str(output[4])                    

pub get_char(p_str, n)

'' Returns nth character from str at p_str

  if (n < strsize(p_str))
    return byte[p_str][n]
  else
    return "?"  
                           